package guard.api.sensitive.ui.sapiguard.hookedapis;

import java.util.ArrayList;
import java.util.List;

import guard.api.sensitive.ui.sapiguard.utils.PrivacyManager;
import guard.api.sensitive.ui.sapiguard.XHook;
import guard.api.sensitive.ui.sapiguard.utils.XParam;

public class XNfcAdapter extends XHook {
	private Methods mMethod;

	protected XNfcAdapter(Methods method, String restrictionName) {
		super(restrictionName, method.name(), null);
		mMethod = method;
	}

	@Override
	public String getClassName() {
		return "android.nfc.NfcAdapter";
	}

	private enum Methods {
		getDefaultAdapter, getNfcAdapter
	};

	// public static NfcAdapter getDefaultAdapter() [deprecated]
	// public static NfcAdapter getDefaultAdapter(Context context)
	// public static synchronized NfcAdapter getNfcAdapter(Context context)
	// frameworks/base/core/java/android/nfc/NfcAdapter.java
	// http://developer.android.com/reference/android/nfc/NfcAdapter.html

	// NfcManager.getDefaultAdapter calls NfcAdapter.getNfcAdapter
	// http://developer.android.com/reference/android/nfc/NfcManager.html

	public static List<XHook> getInstances() {
		List<XHook> listHook = new ArrayList<XHook>();
		listHook.add(new XNfcAdapter(Methods.getDefaultAdapter, PrivacyManager.cNfc));
		listHook.add(new XNfcAdapter(Methods.getNfcAdapter, PrivacyManager.cNfc));
		return listHook;
	}

	@Override
	protected void before(XParam param) throws Throwable {

	}

	@Override
	protected void after(XParam param) throws Throwable {
		// Do nothing
	}
}
